%===============================
%  BEYCAN KAHRAMAN - 040020337
% ODE : NUMERICAL SOLUTIONS 2.1
%===============================

% Euler Yntemi ile Balang 
%   Deer Problemini zmek

% CALISTIRMAK ICIN
% euler('f', 'fr', 0, 2, 0.5, 10)

function E = euler(f, fr, a, b, ya, M)
% f is the function
% a and b are left and right points
% ya is tha initial condition
% M is the number of steps
h = (b - a) / M;
T = zeros(1, M+1);
Y = zeros(1, M+1);
K = zeros(1, M+1);

T = a:h:b;
Y(1) = ya;

for J = 1:M;
    Y(J+1) = Y(J) + h*feval(f, T(J), Y(J));
    K(J) = feval(fr, T(J), Y(J));
end
K(J+1) = feval(fr, T(J+1), Y(J+1));

plot(T, Y, '-*r', T, K, 'x:b');
legend('taylor', 'euler','exact');
xlabel('T');
ylabel('Y');
title('Euler Method vs Taylor Method for Solving ODE (0:0.2:2 - 0.5) / Beycan KAHRAMAN - 040020337');

E = [T', Y'];
% kolon vektr olarak vermesi iin ' koyduk
