% - - - - - - - - - - - - - - - - - - - - - - -
%
% This program implements Taylor's method
%
% for solving the initial value problem
%
%     y' = f(t,y)    with    y(a) = y0
%
%
% Define and store the function d1 = f(t,y)	
% and formulas for the next three derivatives
% of  f(t,y)  in the M-file  df.m 
% function z = df(t,y)
% d1 = (t - y)/2;
% d2 = (2 - t + y)/4;
% d3 = (- 2 + t - y)/8;
% d4 = (2 - t + y)/16;
% z = [d1 d2 d3 d4];

clc;
%.......................................................................
% Begin a section which enters the function(s) necessary for the example
% into M-file(s) by executing the diary command in this script file.
% The preferred programming method is not to use these steps.
% One should enter the function(s) into the M-file(s) with an editor.


clc;

% - - - - - - - - - - - - - - - - - - - - - - - - - - -
%
%  Use Taylor's method to solve
% the differential equation  y' = (t-y)/2.
%
% Enter the endpoints a and b of the interval [a,b].
% Enter the initial value y(a) in  ya.
% Enter the number of subintervals in  m.

a  =  0;
b  =  2;
ya =  0.5;
m  =  10;

[T,Y] = taylor('df',a,b,ya,m);


plot(T,Y, 's-g')